/*
 * Copyright (c) 2022 VMware, Inc. All Rights Reserved.
 */

const fs = require('fs');

const smDeployment =  process.env.SELF_MANAGED_DEPLOYMENT === "true";
const ffConfigFile = process.env.FF_CONFIG_FILE || "ff_config.json";

function gatewayConfig(){
    let gatewayConfigFile = process.env.GATEWAY_CONFIG_FILE;
    let local_csp_ff_sdk_config;
    if (!gatewayConfigFile) {
        // read local config if not overridden
        gatewayConfigFile = "gateway_config.json";
        local_csp_ff_sdk_config = "csp_ff_sdk_config_local.json";
    }
    const fileContents = fs.readFileSync(gatewayConfigFile, 'utf8')
    let gatewayConfig = JSON.parse(fileContents);
    if (!smDeployment && local_csp_ff_sdk_config){
        let cspFFSdkConfig = fs.readFileSync(local_csp_ff_sdk_config, 'utf8');
        gatewayConfig = Object.assign(gatewayConfig, JSON.parse(cspFFSdkConfig))
    }
    return gatewayConfig
}

function ffConfig(){
    if (smDeployment){
        const fileContents = fs.readFileSync(ffConfigFile, 'utf8')
        let ffContent = JSON.parse(fileContents) || null;
        return ffContent;
    } else  {
        return null;
    }
}

module.exports.gatewayConfig = gatewayConfig;
module.exports.ffConfig = ffConfig;
module.exports.smDeployment = smDeployment;